/**
*	File: mst_stepper.js
*	Version: 1.0
*	Author: Wellcom Worldwide
*
*	Description: 
*
*	This file contains the stepper functionality used for Mercer Style Guide
*	Allows for vertical and horizontal initializations.
*	
*/

;(function($) {



	// Check that jQuery exists.
	if(typeof $ == "undefined" && typeof jQuery == "undefined") {
		throw new Error('JQuery must be loaded.');
	} else if ( typeof $ == "undefined" && typeof jQuery != "undefined") {
		var $ = jQuery;
	}



	$.fn.__mstEqualizer = function ( opts ) {


		var selectedObjects = this;


		var settings = $.extend({
			mobileBreakpoint: 768,
			childEqualizerClass: '.__mst_equalizer_child',
			useMinHeight: true
			// Silence is golden.
		}, opts);




		var pluginMethods = {
			__init: function ( selectedObjects ) {


				$.each(selectedObjects, function( i , o ) {

					var selector = $(this);

					// Ensure that the equalizer class is set.
					if( !selector.hasClass('__mst_equalizer') ) {
						selector.addClass('__mst_equalizer');
					}


					pluginMethods.equalizeIt( selector );

				});

			},
			equalizeIt: function( selector ) {

				var children = selector.find( settings.childEqualizerClass );
				var childMaxHeight = null;



				// Determine the Maximum Child Height
				$.each(children, function( i , o ) {


					var child = $(this);

					if ( typeof child.attr('style') != "undefined" && child.attr('style') != "" && child.attr('style') != null ) {

						child.removeAttr('style');

					}

					var childHeight = child.outerHeight();

					if( childMaxHeight == null || childMaxHeight < childHeight ) {
						
						childMaxHeight = childHeight;

					}


				});



				// Now apply it to all of the child classes
				$.each(children, function( i , o ) {

					var child = $(this);

					if( $(window).outerWidth() >= settings.mobileBreakpoint ) {
						if( settings.useMinHeight ) {
							child.css('min-height', childMaxHeight + 'px');
						} else {
							child.css('height', childMaxHeight + 'px');
						}
					} else {
						if( settings.useMinHeight ) {
							child.css('min-height', 'auto');
						} else {
							child.css('height', 'auto');
						}
					}

				});

			}

		};





		
		// Run the loop
		pluginMethods.__init( selectedObjects );


		$(window).on('resize', function(ev) {
			pluginMethods.__init( selectedObjects );
		});





	};






}(jQuery));